*
      SUBROUTINE CAL_GESVD1(NAME, M, N, NPROW, NPCOL, AMEM,
     $                      MEMSIZE, NB, INFILEA, OUTFILE)
*
*      (PDGESVD1, PDGESVD4)
*        QD - 
*
      include 'mpif.h'
*
*  
      INTEGER            M, N, NPROW, NPCOL, NB, MEMSIZE
      DOUBLE PRECISION   AMEM( MEMSIZE )
      CHARACTER*(*)      INFILEA, OUTFILE, NAME
*
*   -  
      INTEGER            NOUT, NIN, NPR
      PARAMETER          ( NOUT =13, NIN = 11, NPR = 6 )
*
*  
      INTEGER            CTXT, I, IAM, INFO, IA, JA,
     $                   IPA, IPS, IPW, IPWOR,
     $                   LWMIN, MAXIM, MP, MMIN,
     $                   NP, NQ, NP0, NQ0, MYCOL, MYROW,
     $                   MXNP, MXNQ, LWORK,
     $                   NPROCS, WORKSIZ, SIZE, SIZEB,
     $                   WATOBD, WBDTOSVD, WDBDSQR, WPDGEBRD, WPDLANGE
*  
      INTEGER            DESCA( 9 )
*
*  
      INTEGER            NUMROC
      EXTERNAL           NUMROC
*
*  
      EXTERNAL           BLACS_EXIT, BLACS_GET, BLACS_GRIDEXIT,
     $                   BLACS_GRIDINFO, BLACS_GRIDINIT, BLACS_PINFO,
     $                   BLACS_SETUP, DESCINIT, IGSUM2D, PDLAPRNT,
     $                   PDLAREAD, PDLAWRITE, PDGESVD1, PDGESVD4
*
*  
      INTRINSIC          MAX, MIN
*
*  
*
*  
*
      IA = 1
      JA = 1
*
*   BLACS
*
      CALL BLACS_PINFO( IAM, NPROCS )
*
        IF( NPROCS.LT.1 ) THEN
           CALL BLACS_SETUP( IAM, NPROCS )
*           CALL BLACS_SETUP( IAM, NPROW*NPCOL )
        END IF
*
*   BLACS'   
*
      CALL BLACS_GET( -1, 0, CTXT )
      CALL BLACS_GRIDINIT( CTXT, 'R', NPROW, NPCOL )
      CALL BLACS_GRIDINFO( CTXT, NPROW, NPCOL, MYROW, MYCOL )
*
*       ,
*    
*
      IF( MYROW.GE.NPROW .OR. MYCOL.GE.NPCOL ) GO TO 20
*
       MP = NUMROC( M, NB, MYROW, 0, NPROW )
       NQ = NUMROC( N, NB, MYCOL, 0, NPCOL )
*
*      A
*
      CALL DESCINIT(DESCA, M, N, NB, NB, 0, 0, CTXT, MAX(1,MP), INFO)
*
      SIZE = MIN( M, N )
      SIZEB = MAX( M, N )
*
*     AMEM
*
*     A
      IPA = 1
*
*     S (   )
      IPS = IPA + DESCA(9)*NQ
*     WORK
      IPWOR = IPS + SIZE
*
      MP0 = NUMROC( M, NB, 0, 0, NPROW )
      NQ0 = NUMROC( N, NB, 0, 0, NPCOL )
*
      MAXIM = MAX( MP0, NQ0 )
*
      WPDLANGE = MP
      WPDGEBRD = NB*( MP+NQ+1 ) + NQ
      WATOBD = MAX( MAX( WPDLANGE, WPDGEBRD ), MAXIM )
*
      WDBDSQR = MAX( 1, 2*SIZE )
      WBDTOSVD =  MAX( WDBDSQR, 0)
*
      LWMIN = 2 + 6*SIZEB + MAX( WATOBD, WBDTOSVD )
*
*   ,    PDGESVD1(4)
      LWORK = LWMIN
*
*     W
      IPW = IPWOR + LWORK
*
      IF( NAME .NE. 'PDGESVD1' .AND. NAME .NE. 'PDGESVD4' ) GOTO 10
*
*     PDLAPRNT  .
*?
    3 WORKSIZ = MAX( NB, MP )
*
*        
*
      INFO = 0
      MMIN = IPW + WORKSIZ
*
*      ( MMIN )
*
      IF(IPW + WORKSIZ .GT. MEMSIZE ) THEN
         IF( IAM .EQ. 0 ) WRITE( NPR, FMT = * )'  '
         OPEN( NOUT, FILE = OUTFILE, STATUS = 'UNKNOWN' )
         IF( IAM .EQ. 0 ) WRITE( NOUT, FMT = * )'  '
         INFO = 1
      END IF
*
*   INFO    
*
      CALL IGSUM2D( CTXT, 'All', ' ', 1, 1, INFO, 1, -1, 0 )
      IF( INFO .GT. 0 ) THEN
         OPEN( NOUT, FILE = OUTFILE, STATUS = 'UNKNOWN') 
         IF( IAM .EQ. 0 ) WRITE( NOUT, FMT = * )'  '
         GO TO 10
      END IF
*
*      
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NPR, FMT = 9992 )NAME
         WRITE( NPR, FMT = 9998 )M, N, NB, NB
         WRITE( NPR, FMT = 9997 )NPROW*NPCOL, NPROW, NPCOL
         WRITE( NPR, FMT = * ) '     '
         WRITE( NPR, FMT = * )' IPA,  IPS,  IPWOR,  IPW,  MMIN'
         WRITE( NPR, FMT = 9994 )IPA, IPS, IPWOR, IPW, MMIN
*
         WRITE( NPR, FMT = * ) '  DESCA'
         WRITE( NPR, FMT = 9985 )DESCA
         WRITE( NPR, FMT = * ) '  A'
      END IF
*
*         A
*
      CALL PDLAREAD(INFILEA, AMEM(IPA), DESCA, 0, 0, AMEM(IPW))
*
      CALL PDLAPRNT( M, N, AMEM(IPA), IA, JA, DESCA, 0, 0, 'A',
     $               NPR, AMEM( IPW ) )
*
 9994 FORMAT( / I3, 4I7 /)
 9985 FORMAT( / 9I5 /)
*
*    
*
      IF( NAME .EQ. 'PDGESVD4' ) GOTO 11
      IF( NAME .NE. 'PDGESVD1' ) GOTO 10
*
      CALL PDGESVD1( N, AMEM(IPA), IA, JA, DESCA,
     $              AMEM(IPS), AMEM(IPWOR), LWORK, INFO )
      GOTO 99
*
   11 CALL PDGESVD4( M, N, AMEM(IPA), IA, JA, DESCA,
     $              AMEM(IPS), AMEM(IPWOR), LWORK, INFO)
      GOTO 99
*
*  
*
   99 IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NPR, FMT = * ) '  '
         WRITE( NPR, FMT = 9996 )INFO
*
*         WRITE( NPR, FMT = 9984 )AMEM(IPW)
*
         WRITE( NPR, FMT = * ) '   '
         DO 12 I = IPS, IPS+SIZE-1
         PRINT *, ' S(', I-IPS+1, ')=', AMEM( I ), ';'
   12   CONTINUE
      END IF
*
*     
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         OPEN( NOUT, FILE = OUTFILE, STATUS = 'UNKNOWN' )
         WRITE(NOUT, FMT = *)'   '
*
         WRITE(NOUT, FMT = *) SIZE, 1
         DO 14 I = 1, SIZE
            WRITE( NOUT, FMT = * ) AMEM( IPS+I-1 )
   14    CONTINUE
*
      END IF
*
   10 CONTINUE
*
      CALL BLACS_GRIDEXIT( CTXT )
   20 CONTINUE
*
      IF( IAM .EQ. 0 ) THEN
         IF( NOUT .NE. 6 .AND. NOUT .NE. 0 ) CLOSE( NOUT )
      END IF
*
      CALL BLACS_EXIT( 0 )
*
 9992 FORMAT( / '    ', A8 )
 9998 FORMAT(/'      ',//,
     $       ' A  -   ',I2,'  ',I2,',',
     $       /'         ', I2, '  ', I2, /)
 9997 FORMAT( / '   ', I2, ' ,',
     $       '    ', I2, '  ', I2 /)
 9996 FORMAT( / '  INFO  = ', I6 /)
 9984 FORMAT( / ' LWORK  = ', D7.17 /)
      RETURN
      END
